//------------------------------------------------------------------------------
// File: RateChanger.h
//------------------------------------------------------------------------------

#ifndef __RATECHANGER__
#define __RATECHANGER__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define ULONG_UNIT	unsigned _int64
#define LONG_UNIT	_int64

class RateChanger
{
	ULONG_UNIT	m_lcmrate;				/* least common multiple of rates */
	LONG_UNIT	m_inskip, m_outskip;    /* LCM increments for I & O rates */
	int			m_iRate;
	int			m_oRate;

	struct Channel
	{
		ULONG_UNIT	m_total;
		ULONG_UNIT	m_intot, m_outtot;      /* total samples in terms of LCM rate */
		LONG_UNIT	m_lastsamp;

		Channel() {	m_total = m_intot = m_outtot = 0; m_lastsamp = 0; }
	};
	
	Channel*	m_channels;
	int			m_channelCount;

public:
	RateChanger(int channelCount, int inrate, int outrate);
	~RateChanger();

	int GetInputRate() { return m_iRate; }
	int GetOutputRate() { return m_oRate; }

	void SetChannelCount(int channelCount);
	void SetRate(int inrate, int outrate);
	
	void ProcessFlow32(int channel, long *ibuf, long *obuf, int inlen, int *outlen, int adv);
	void ProcessFlow24(int channel, void *ibuf, void *obuf, int inlen, int *outlen, int adv);
	void ProcessFlow16(int channel, short *ibuf, short *obuf, int inlen, int *outlen, int adv);
	void ProcessFlow8(int channel, unsigned char *ibuf, unsigned char *obuf, int inlen, int *outlen, int adv);
};

#endif // __RATECHANGER__
